Ruby - Bug #7865

A required file is not added to SLOADED_FEATURES until after it has run

02/16/2013 10:29 PM - Anonymous

Backport:

Status: Closed

Priority: Normal

Assignee: matz (Yukihiro Matsumoto)

Target version: 2.6

ruby -v: ruby 2.0.0dev (2013-02-08 trunk 39161)
[x86_64-darwin11.4.0]

Description

=begin

Required files are not added to SLOADED_FEATURES until after they have been executed.

This is easily demonstrated with two files, a.rb and b.rb:

a.rb

require "./b"
p SLOADED_FEATURES.grep(/b.rb/).any?

b.rb

p SLOADED_FEATURES.grep(/b.rb/).any?
Running (({a.rb})) should print:

true
true

But it current prints:
false

true
=end

History

#1 - 02/17/2013 02:03 PM - ko1 (Koichi Sasada)
- Category set to core

- Assignee set to matz (Yukihiro Matsumoto)

- Priority changed from Normal to 5

- Target version set to 2.6

Matz issue?
or other can judge it?

This behavior is same as 1.9.3 or before. So it is not a compatibility issue.

#2 - 02/20/2013 11:49 AM - nobu (Nobuyoshi Nakada)
- Status changed from Open to Closed

- Priority changed from 5 to Normal

=begin

It's an intended behavior, not a bug.

When an exception raised while loading, the feature won't be added to
(({SLOADED_FEATURESY})).

And, it hasn't been loaded yet, has it?
If you want to know what features are now getting loaded, you should
suppose new feature, e.g. ({$LOADING_FEATURES})).
=end
